; В папке images - картинки
; остальные файлы - в той же папке, что и этот файл

; Используемые в патче библиотеки
!include "MUI.nsh"
!include "FileFunc.nsh" ; Для подсчёта размера патча после установки
!include "LogicLib.nsh" ; Для возможности использования for и if

; Включаем сжатие
SetCompressor /SOLID lzma
CRCCheck on
RequestExecutionLevel admin

; Настройки приложения
!define PATCH_NAME "Yume Miru Kusuri Russian Patch" ; Название патча
!define PATCH_FILE "Rus.arc" ; Имя файла патча
!define PATCH_VER "1.2" ; Версия патча
!define PATCH_PATH "Russian" ; Путь к папке для установки деинсталлятора и т.п.

!define APP_NAME "yumemiru" ; Название приложения на англе

!define PATCH_REG "Software\${PATCH_NAME}" ; Путь к ветке реестра с информацией о патче
!define PATCH_UN_REG "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PATCH_NAME}" ; Путь к ветке реестра с информацией о деинсталляторе патча

!define APP_REG "Software\Will\yumemirukusuri" ; Путь к ветке реестра с информацией о настройках игры

Name "${PATCH_NAME}"
InstallDir "$PROGRAMFILES\Peach Princess\YUME MIRU KUSURI\"
InstallDirRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\{03ABC33C-10B1-400E-B1FA-E817FE98D11C}" "InstallLocation"
OutFile "YMK_russian_patch_${PATCH_VER}.exe"
Caption "Установка ${PATCH_NAME} ${PATCH_VER}"
BrandingText " "

; Иконки
!define MUI_ICON "images\YMK.ico" ; Инсталлятор
!define MUI_UNICON "images\YMK.ico" ; Деинсталлятор

; Левое изображение 164х314
!define MUI_WELCOMEFINISHPAGE_BITMAP "images\YMK_left.bmp" ; Инсталлятор
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "images\YMK_left.bmp" ; Деинсталлятор

; Верхнее изображение 150x57
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "images\YMK_header.bmp" ; Инсталлятор
!define MUI_HEADERIMAGE_UNBITMAP "images\YMK_header.bmp" ; Деинсталлятор
!define MUI_HEADERIMAGE_RIGHT

!define MUI_ABORTWARNING ; Указываем, что при нажатии кнопки "Отмена" в процессе установки, будет выдаваться уточняющий диалог

; Шаги инсталлятора
!define MUI_WELCOMEPAGE_TITLE_3LINES ; Увеличиваем высоту шапки в следующем шаге
!insertmacro MUI_PAGE_WELCOME ; Шаг приветствия
!insertmacro MUI_PAGE_LICENSE "license.txt" ; Шаг с текстом лицензии
!insertmacro MUI_PAGE_DIRECTORY ; Шаг выбора папки
!insertmacro MUI_PAGE_INSTFILES ; Шаг установки файлов
!define MUI_FINISHPAGE_TITLE_3LINES ; Увеличиваем высоту шапки в следующем шаге
!insertmacro MUI_PAGE_FINISH ; Шаг завершения установки

; Шаги деинсталлятора
!define MUI_WELCOMEPAGE_TITLE_3LINES ; Увеличиваем высоту шапки в следующем шаге
!insertmacro MUI_UNPAGE_WELCOME ; Шаг приветствия
!insertmacro MUI_UNPAGE_CONFIRM ; Шаг подтверждения деинсталляции по указанному адресу
!insertmacro MUI_UNPAGE_INSTFILES ; Шаг деинсталляции файлов
!define MUI_FINISHPAGE_TITLE_3LINES ; Увеличиваем высоту шапки в следующем шаге
!insertmacro MUI_UNPAGE_FINISH ; Шаг завершения деинсталляции

; Определяем языки установщика
!insertmacro MUI_LANGUAGE "Russian"

; Блок инсталлятора
Section "Install"
; Копируем файлы
	SetOverwrite on
	CreateDirectory "$INSTDIR\${PATCH_PATH}"

	SetOutPath "$INSTDIR\${PATCH_PATH}"
	File "license.txt"
	File "readme_ru.txt"

	SetOutPath "$INSTDIR\"
	File "Rus.arc"
	File "yumemiru_rus.exe"

; Получаем размер установленных файлов, но в Windows XP всё равно будет показываться фигня
	${GetSize} "$INSTDIR" "/M=Rus.arc /S=0K /G=0" $0 $2 $3
	${GetSize} "$INSTDIR" "/M=yumemiru_rus.exe /S=0K /G=0" $1 $2 $3
	IntOp $0 $0 + $1
	${GetSize} "$INSTDIR\${PATCH_PATH}" "/M=license.txt /S=0K /G=0" $1 $2 $3
	IntOp $0 $0 + $1
	${GetSize} "$INSTDIR\${PATCH_PATH}" "/M=readme_ru.txt /S=0K /G=0" $1 $2 $3
	IntOp $0 $0 + $1
	IntFmt $0 "0x%08X" $0

; Создаём денсталлятор
	WriteUninstaller "$INSTDIR\${PATCH_PATH}\Uninstall ${PATCH_NAME}.exe"

; Заносим информацию в реестр
	WriteRegStr HKLM "${PATCH_REG}" "InstallDir" "$INSTDIR"
	WriteRegStr HKLM "${PATCH_REG}" "Revision" "${PATCH_VER}"

	WriteRegStr HKLM "${PATCH_UN_REG}" "DisplayName" "${PATCH_NAME}"
	WriteRegStr HKLM "${PATCH_UN_REG}" "DisplayVersion" "${PATCH_VER}"
	WriteRegDWORD HKLM "${PATCH_UN_REG}" "NoModify" "1"
	WriteRegDWORD HKLM "${PATCH_UN_REG}" "NoRepair" "1"
	WriteRegDWORD HKLM "${PATCH_UN_REG}" "EstimatedSize" "$0"
	WriteRegStr HKLM "${PATCH_UN_REG}" "DisplayIcon" "$INSTDIR\${APP_NAME}.exe"
   
	WriteRegStr HKLM "${PATCH_UN_REG}" "UninstallString" "$INSTDIR\${PATCH_PATH}\Uninstall ${PATCH_NAME}.exe"

; Заносим информацию в реестр о настройках самой игры (на всякий случай)
	WriteRegStr HKCU "${APP_REG}" "InstallSrc" "."
	WriteRegStr HKCU "${APP_REG}" "InstallDir" "."
	WriteRegStr HKCU "${APP_REG}" "FontName" "Lucida Console"
	
; Создаём пункт в меню "Пуск", если в нём уже есть соответствующая папка
	SetShellVarContext all ; Эта программа устанавливается в All Users
	IfFileExists "$SMPROGRAMS\YUMEMIRUKUSURI" 0 lbl_NoStartMenu
		CreateShortCut "$SMPROGRAMS\YUMEMIRUKUSURI\Запустить Yume Miru Kusuri.lnk" "$INSTDIR\yumemiru_rus.exe" "" "$INSTDIR\${PATCH_PATH}\Uninstall ${PATCH_NAME}.exe" 0
		CreateShortCut "$SMPROGRAMS\YUMEMIRUKUSURI\Удалить ${PATCH_NAME}.lnk" "$INSTDIR\${PATCH_PATH}\Uninstall ${PATCH_NAME}.exe" "" "$INSTDIR\${PATCH_PATH}\Uninstall ${PATCH_NAME}.exe" 0
lbl_NoStartMenu:
		
SectionEnd

; Блок деинсталлятора
Section "Uninstall"
	SetOverwrite on
	SetShellVarContext all ; Эта программа удаляется из All Users

; Удаляем файлы
	Delete "$INSTDIR\Rus.arc"
	Delete "$INSTDIR\yumemiru_rus.exe"

	Delete "$INSTDIR\${PATCH_PATH}\license.txt"
	Delete "$INSTDIR\${PATCH_PATH}\readme_ru.txt"
	Delete "$INSTDIR\${PATCH_PATH}\Uninstall ${PATCH_NAME}.exe"
	RMDir "$INSTDIR\${PATCH_PATH}"

	Delete "$SMPROGRAMS\YUMEMIRUKUSURI\Удалить ${PATCH_NAME}.lnk"
	Delete "$SMPROGRAMS\YUMEMIRUKUSURI\Запустить Yume Miru Kusuri.lnk"
	RMDir "$SMPROGRAMS\YUMEMIRUKUSURI"

; Удаляем информацию из реестра
	DeleteRegKey HKLM "${PATCH_UN_REG}"
	DeleteRegKey HKLM "${PATCH_REG}"
SectionEnd

; Выполняется в момент инициализации инсталлятора
Function .onInit
; Проверка на наличие уже установленного патча и самой игры
	ClearErrors
	ReadRegStr $0 HKLM "${PATCH_REG}" "InstallDir"
	IfErrors lbl_PatchNotInstalled
		MessageBox MB_YESNO|MB_ICONQUESTION "${PATCH_NAME} уже установлен.$\nВы уверены, что хотите продолжить?" IDYES lbl_PatchNotInstalled
		Quit
lbl_PatchNotInstalled:
FunctionEnd

; Выполняется в момент выбора папки для установки
Function .onVerifyInstDir
	IfFileExists "$INSTDIR\${APP_NAME}.exe" lbl_PathGood
		Abort
lbl_PathGood:
FunctionEnd

; Выполняется в момент инициализации деинсталлятора
Function un.onInit
; Устанавливаем путь к приложению (если этого не сделать, в $INSTDIR будет путь к патчу, а не к приложению)
	StrLen $1 $INSTDIR
	StrLen $2 ${PATCH_PATH}
	IntOp $1 $1 - 1
	IntOp $1 $1 - $2
	StrCpy $INSTDIR $INSTDIR $1
FunctionEnd

; eof